From 219c0790d4e157ca358d5a7baa08972ab6fcd4af Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 26 2020 01:02:15 +0000
Subject: [PATCH 422/2232] Generate data accessor for Vec


---

diff --git a/gen/write.rs b/gen/write.rs
index f8bd1d8..9192a7e 100644
--- a/gen/write.rs
+++ b/gen/write.rs
@@ -1021,6 +1021,11 @@ fn write_rust_vec_extern(out: &mut OutFile, ty: &Type) {
         "size_t cxxbridge02$rust_vec${}$len(const ::rust::Vec<{}> *ptr) noexcept;",
         instance, inner,
     );
+    writeln!(
+        out,
+        "const {} *cxxbridge02$rust_vec${}$data(const ::rust::Vec<{0}> *ptr) noexcept;",
+        inner, instance,
+    );
     writeln!(out, "#endif // CXXBRIDGE02_RUST_VEC_{}", instance);
 }
 
@@ -1061,6 +1066,15 @@ fn write_rust_vec_impl(out: &mut OutFile, ty: &Type) {
     writeln!(out, "size_t Vec<{}>::size() const noexcept {{", inner);
     writeln!(out, "  return cxxbridge02$rust_vec${}$len(this);", instance);
     writeln!(out, "}}");
+
+    writeln!(out, "template <>");
+    writeln!(out, "const {} *Vec<{0}>::data() const noexcept {{", inner);
+    writeln!(
+        out,
+        "  return cxxbridge02$rust_vec${}$data(this);",
+        instance,
+    );
+    writeln!(out, "}}");
 }
 
 fn write_unique_ptr(out: &mut OutFile, ty: &Type, types: &Types) {
diff --git a/include/cxx.h b/include/cxx.h
index d3721ea..c3037bd 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -209,6 +209,7 @@ public:
 
   size_t size() const noexcept;
   bool empty() const noexcept { return size() == 0; }
+  const T *data() const noexcept;
 
 private:
   void drop() noexcept;
diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 81cf025..15351f0 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -540,10 +540,12 @@ fn expand_rust_vec(namespace: &Namespace, ty: &Type, ident: &Ident) -> TokenStre
     let link_prefix = format!("cxxbridge02$rust_vec${}", mangled);
     let link_drop = format!("{}drop", link_prefix);
     let link_len = format!("{}len", link_prefix);
+    let link_data = format!("{}data", link_prefix);
 
     let local_prefix = format_ident!("{}__vec_", ident);
     let local_drop = format_ident!("{}drop", local_prefix);
     let local_len = format_ident!("{}len", local_prefix);
+    let local_data = format_ident!("{}data", local_prefix);
 
     let span = ty.span();
     quote_spanned! {span=>
@@ -557,6 +559,11 @@ fn expand_rust_vec(namespace: &Namespace, ty: &Type, ident: &Ident) -> TokenStre
         unsafe extern "C" fn #local_len(this: *const ::cxx::private::RustVec<#inner>) -> usize {
             (*this).len()
         }
+        #[doc(hidden)]
+        #[export_name = #link_data]
+        unsafe extern "C" fn #local_data(this: *const ::cxx::private::RustVec<#inner>) -> *const #inner {
+            (*this).as_ptr()
+        }
     }
 }
 
diff --git a/src/rust_vec.rs b/src/rust_vec.rs
index 1c0c64f..32db8cc 100644
--- a/src/rust_vec.rs
+++ b/src/rust_vec.rs
@@ -29,6 +29,10 @@ impl<T> RustVec<T> {
     pub fn len(&self) -> usize {
         self.repr.len()
     }
+
+    pub fn as_ptr(&self) -> *const T {
+        self.repr.as_ptr()
+    }
 }
 
 const_assert_eq!(mem::size_of::<[usize; 3]>(), mem::size_of::<Vec<i32>>());

